<template>
  <mt-box padding="0">
    <!-- @TODO remettre les chevron pour mobile -->
    <mt-chevron type="left" title="mois précédent" @click="moisPrecedent"></mt-chevron>
    <div class="mt-box-activites-header">
      <div class="column is-hidden-tablet">
        <slot name="recherche"></slot>
      </div>
      <div class="columns is-mobile is-vcentered">
        <div class="column is-narrow mt-padding-0">
          <mt-chevron type="left" title="mois précédent" is-mobile @click="moisPrecedent"></mt-chevron>
        </div>
        <div class="columns column ">
          <div class="column is-hidden-mobile">
            <slot name="recherche">
              <div v-if="groupes != null && groupes.length > 0">
                Voir les activités du :
                <b-dropdown
                  ref="dropdown"
                  v-model="groupesSelect"
                  multiple
                  aria-role="list"
                  class="is-hidden-mobile"
                  @change="selectGroup()"
                >
                  <template #trigger>
                    <b-button type="is-primary" icon-right="menu-down" class="mt-group-select">
                      Groupes ({{ groupesSelect.length }})
                    </b-button>
                  </template>
                  <b-dropdown-item
                    v-for="(groupeItem, index) in groupes"
                    :key="index"
                    custom
                    :value="groupeItem.id"
                    aria-role="listitem"
                  >
                    <b-checkbox
                      v-model="chkGroup"
                      :native-value="groupeItem.id"
                      @input="$refs.dropdown.selectItem(groupeItem.id)"
                    >
                      <div class="columns">
                        <div class="column">{{ groupeItem.nom }}</div>
                        <div class="column is-narrow">
                          <mt-count-utilisateur
                            :nombre="groupeItem.groupesPersonnaliserDetails.length"
                          ></mt-count-utilisateur>
                        </div>
                      </div>
                    </b-checkbox>
                  </b-dropdown-item>
                </b-dropdown>
              </div>
              <div>
                <b-tag
                  v-for="(selected, index) in getSelectedGroupes()"
                  :key="`env${index}`"
                  class="mt-selected"
                  closable
                  @close="removeSelectedGroupe(index)"
                >
                  {{ selected.nom }}
                </b-tag>
              </div>
            </slot>
          </div>
          <div class="mt-datepicker column is-narrow columns is-vcentered">
            <b-datepicker
              class="cursor-as-pointer datepickerCalendar"
              :value="dateCourante"
              :date-formatter="dateFormatter"
              type="month"
              :month-names="monthNames"
              icon="menu-down"
              :mobile-native="false"
              @input="moisSelectionne"
            />
          </div>
        </div>
        <div class="column is-narrow mt-padding-0">
          <mt-chevron type="right" is-mobile title="mois suivant" @click="moisSuivant"></mt-chevron>
        </div>
      </div>
    </div>
    <slot></slot>
    <mt-chevron type="right" title="mois suivant" @click="moisSuivant"></mt-chevron>
  </mt-box>
</template>

<script>
import { DateTime } from 'luxon';
import MtBox from '~/components/base/box';
import MtChevron from '~/components/base/chevron/index';
import MtCountUtilisateur from '~/components/pax/mt-count-utilisateur';

export default {
  components: {
    MtChevron,
    MtBox,
    MtCountUtilisateur,
  },
  props: {
    groupes: {
      type: Array,
      default: () => [],
    },
    selectedGroupes: {
      type: Array,
      default: () => [],
    },
    dateCourante: {
      type: Date,
      default: () => new Date(),
    },
    monthNames: {
      type: Array,
      default: () => [
        'Janvier',
        'Février',
        'Mars',
        'Avril',
        'Mai',
        'Juin',
        'Juillet',
        'Août',
        'Septembre',
        'Octobre',
        'Novembre',
        'Décembre',
      ],
    },
  },
  data() {
    return {
      groupesSelect: [],
      chkGroup: [],
    };
  },
  created() {
    this.groupesSelect = this.selectedGroupes;
    this.chkGroup = this.selectedGroupes;
  },
  methods: {
    dateFormatter(date) {
      return DateTime.fromJSDate(date)
        .setLocale('fr')
        .toFormat('LLLL y');
    },
    moisSelectionne(date) {
      this.$emit('mois-selectionne', {
        firstCellDate: DateTime.fromJSDate(date)
          .startOf('month')
          .startOf('week')
          .toJSDate(),
        lastCellDate: DateTime.fromJSDate(date)
          .startOf('month')
          .plus({ weeks: 5 })
          .endOf('week')
          .toJSDate(),
        startDate: date,
      });
    },
    moisPrecedent() {
      const futureDateCourante = new Date(this.dateCourante.setMonth(this.dateCourante.getMonth() - 1));
      this.moisSelectionne(futureDateCourante);
    },
    moisSuivant() {
      const futureDateCourante = new Date(this.dateCourante.setMonth(this.dateCourante.getMonth() + 1));
      this.moisSelectionne(futureDateCourante);
    },
    removeSelectedGroupe(index) {
      this.chkGroup.splice(index, 1);
      this.groupesSelect.splice(index, 1);
      this.selectGroup();
    },
    selectGroup() {
      this.$emit('select-groupes', this.groupesSelect);
    },
    getSelectedGroupes() {
      return this.groupes.filter((group) => this.groupesSelect.includes(group.id));
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
.mt-box-activites-header {
  padding: 1rem;
  border-bottom: 1px solid rgba($grey, 0.25);
}
.mt-padding-0 {
  padding: 0;
}
@media screen and (max-width: 768px) {
  /deep/ .datepicker .datepicker-table .datepicker-body .datepicker-months {
    width: 14rem;
  }
}

/deep/ .datepickerCalendar .control.has-icons-left .icon {
  left: 9rem;
  color: $brown-grey;
}
.mt-group-select {
  border-radius: 2rem;
  width: calc(100% - 4px);
  background-color: $macaroni-and-cheese;
  color: white;
  font-size: $size-7;
  padding: 0.3em 1em;
  margin: 0 0.25em;
  cursor: pointer;
  transition-property: background-color, color;
  transition-duration: 0.3s;
  border: solid 1px $macaroni-and-cheese;
  position: relative;
  &.is-primary {
    background-color: $yellow-groupe;
    color: $macaroni-and-cheese;
  }
  &:hover {
    background-color: #ffe38d;
    color: white;
  }
}
.mt-selected {
  background-color: $pale-grey;
  color: #666ee8;
  padding: 0.5em 1em;
  margin: 0.25em;
  font-size: 0.6875rem;
  cursor: default;
}
/deep/ .control-label {
  width: 100% !important;
}
/deep/ .b-checkbox {
  width: 100% !important;
}
</style>
